#include <stdio.h>
#include "grade.h"
#include "rpmpldi.h"
#include "module.h"
#include "mopcapi.h"
#include "mess.h"
#include "net.h"
#include "cfile.h"
#include "ui_dml.h"
#include "dmlwrapper.h"
#include "bug.h"
#include "login.h"

static char *rline()
{
	char buf[1000];
	fgets(buf,sizeof(buf),stdin);
	if(buf[strlen(buf)-1]=='\n')buf[strlen(buf)-1]=0;
	return strdup(buf);
}


	
void printGradesHelp()
{
	printf("Dostepne oceny:\n-1  -- nie wiem\n 0  -- nie dziala\n");
	printf(" 3  -- raczej nie dziala\n 7  -- raczej dziala\n");
	printf(" 10 -- dziala\n");
}

void UIcheckForBug(TpkgDescribe *pk,TpkgDescribe *env,
		int envCount, Tgrade *gr, int grCount)
{
	int i,bug;
	int count, *id;
	char **cathegory;
	char title[10000];
	char *text;
	int cid;
	Tbug *bugR;

	bug=0;
	for(i=0;i<grCount;i++)
		if(gr[i].grade <5 && gr[i].grade > -1 )
			bug=1;
	if(bug==0)
		return;
	if(!dmlAskForBugReport())
		return;
	cathegory=getCathegory(&count, &id);
	
	i=dmlEditBugReport(pk->name, cathegory, id,count,title,&cid,&text);
	if(!i){
		dmlMsgBox("Wysylanie bugreportu anulowane\n");
		return;
	}
	printf("text to %s\n",text);
	bugR = bugNew(pk,env, envCount);
	bugR->title = title;
	bugR->text= text;
	bugR->cathegory = cid;
	sendBugReport(bugR);
	printf("BUG REPORT \n TO JEST TO");
			
}

static void UIgradePkg(char *name)
{

	tn_list *req;
	tn_list_iterator it;
	TpkgDescribe pk,*env,*next;
	int enCount;
	int i,j;
	int *featuresIDs, *marks;
	char **cat;
	Tgrade *gr, *lastGr;
	int grCount, lastGrCount;

printf("\n\nW UIgradPKG 1\n");
	req=rpmpldi_allRequired(name,&pk);
	if(!req){
		printf("Blad w wyszukiwaniu zaleznosci");
		return;
	}

	n_list_iterator_start(req,&it);
	printf("\nZ Listy wymaganych:\n");
	enCount=0;
	/*XXX error */
	while((next=(TpkgDescribe*)n_list_iterator_get(&it))){
			printf("Wymagany pakiet: %s-%s-%s\n",next->name,
					next->evr,next->arch);
			enCount++;
	}
	printf("W sumie %d pakietow\n",enCount);
	env=(TpkgDescribe *)malloc(sizeof(TpkgDescribe)*enCount);
	
	n_list_iterator_start(req,&it);
	i=0;
	while((next=(TpkgDescribe *)n_list_iterator_get(&it))){
		/* note, that if you free 'req', 'evr' will be inaccessible*/
			memcpy(env+i,next,sizeof(TpkgDescribe));
			i++;
	}
	
	/* check if user has already graded this package */
	lastGr = receiveReport(&pk, &lastGrCount);
	for(i=0;i<lastGrCount;i++)
		assert(lastGr[i].grade < 11);
	featuresIDs=getPackageFeatures(pk.name);
	for(i=0;i<lastGrCount;i++)
		assert(lastGr[i].grade < 11);
	for(grCount=0;featuresIDs[grCount];grCount++)
		;
	gr = malloc(sizeof(Tgrade) * grCount);
	marks = malloc(sizeof(int) * grCount);
	cat = malloc(sizeof(char *) * grCount);
	for(i=0;i<lastGrCount;i++)
		assert(lastGr[i].grade < 11);
	for(i=0;i<grCount; i++){
		gr[i].featureNo = featuresIDs[i];
		marks[i]=-1;
		cat[i] = getFeature(featuresIDs[i]);
	}
	for(i=0;i<lastGrCount; i++)
		for(j=0;j<grCount;j++)
			if(lastGr[i].featureNo == featuresIDs[j])
				marks[j]=lastGr[i].grade;
	
	if(dmlGradePackage(pk.name, pk.evr, cat, marks, grCount)){
		for(i=0;i<grCount;i++){
			gr[i].grade=marks[i];
		}
		sendReport(&pk,env,enCount,gr,grCount);	
		runDml("Twoj raport zostyal wyslany<br><button>");
		UIcheckForBug(&pk,env,enCount,gr,grCount);
	}else{
		runDml("Twoj raport nie zostal wyslany<br><button>");
	}
}



static void UIgradeAnyPackage()
{
	char *name;
	printf("Pakiet do opiniowania : ");
	name = rline();
	UIgradePkg(name);
}

static void UIgradeFromTest()
{
	char *name;
	char **pkgs;
	int count;
	char **dists;
	int *id, distId;
	
	
	dists=getDists( &count, &id);
	distId = dmlSelectDist(dists,id,count);
		
	pkgs = getPackagesFromDist(&count,distId);
	name = dmlSelectPackage("Oto lista pakietow zainstalowanych u Ciebie<br>pochadzacych z wybranej dystrybucji<br>",pkgs,count);
	if(name == NULL)
		return;
	UIgradePkg(name);
}


void UIaddFeature()
{
	char *name;
	printf("--------------- Adding new feature -----------------------\n");
	printf("Enter feature description:");
	name=rline();
	addFeature(name);
	printf("This feature ID is %d\n",getFeatureID(name));
	printf("Feaure added\n");
	free(name);
}
	

void UIaddFeatureToPackage()
{
	char *name,*feat,*ask;
	printf("Package to which you want to add a feature: ");
	name=rline();
	printf("Feature id: ");
	feat=rline();
	printf("Are you sure that you want to add feature :\n\"%s\"\n",
			getFeature(atoi(feat)));
	printf("to package \"%s\" [Y/other key=no]?",name);
	ask=rline();
	if(ask[0]=='y' || ask[0]=='Y'){
		addFeatureToPackage(name,atoi(feat));
		printf("Added\n");
	}else{
		printf("Action canceled\n");
	}
	free(name);
	free(feat);
	free(ask);
}
	
	
void UIlistFeatures()
{
	int i,max;
	FILE *fd=NULL;
	
	if(getPager()){
		fd=popen(getPager(),"w");
		if(!fd)
			printf("can't open pager: %s !\n",getPager());
	}
	

	max=getMaxFeatureID();
	for(i=1;i<=max;i++){
		fprintf(fd?fd:stdout,"[%3d] %s\n",i,getFeature(i));
	}
	if(fd)
		pclose(fd);
	
	
}

void UIbrowseStatistic()
{
	char **needed;
	char command[100000]; /* it could be very, very long */
	TpkgDescribe *env,pkg;
	int envCount,maxEnv,i;
	
	printf("Package for statistic geneation (name) : ");
	pkg.name=rline();
	
	printf("Package for statistic geneation (full version) : ");
	pkg.evr=rline();
	
	printf("Package for statistic geneation (arch) : ");
	pkg.arch=rline();
	
	needed=getPackagesForStatistic(pkg.name,&maxEnv);
	printf("Pobieranie infomracji o %d zainstalowanych pakietach\n",maxEnv);
	env=malloc(sizeof(TpkgDescribe)*maxEnv);
	envCount=0;
	for(i=0;i<maxEnv;i++){
		printf("Sprawdzam na okolicznosc %s\n",needed[i]);
		env[envCount]=rpmpldi_getPkgDesc(needed[i]);
		if(env[envCount].name){
			printf("I have got pkg %s\n",env[envCount].name);
			envCount++;
		}
	}
	sprintf(command,"%s \"%s/enter.php?pkg=%s&evr=%s&arch=%s&env_count=%d&",
			getMopBrowser(), getMopWWW(),
			pkg.name, pkg.evr, pkg.arch, envCount);
	for(i=0;i<envCount;i++){
		char buf[1000];
		sprintf(buf,"env%d=%s&env_evr%d=%s&",i+1,env[i].name,i+1,
				env[i].evr);
		strcat(command,buf);
	}
	strcat(command,"\"");
	printf("\nKomanda:\n%s\n\n",command);
	system(command);
		
//	getStatistic(&pkg,env,envCount);
	
}
		
	
void grade(char *destDir)
{
	int mode;
	struct rpmmen_cb cb={
		NULL,
		NULL,
		NULL,
		NULL,
		NULL,
		NULL
	};



	if(doLogin()==0){
		runDml("Login error -- sory no bonus<button>");
		return;
	}
	runDml("Login ok<br><button>");

	if(rpmpldi_init_ro("",destDir,&cb)){
		printf("Nie moge otworzyc BAZY !\n");
		return;
	}

#if 0
	printf("\nMode of operation\n");
	printf("0 - grade package\n");
	printf("1 - add feature\n");
	printf("2 - add feature to package\n");
	printf("3 - list aviable featuers\n");
	printf("4 - browse statistic\n");
	mode = rline();
#endif
	
	do{
		mode = dmlMainMenu();
		switch (mode) {
			case 0:
				UIgradeAnyPackage();
				break;
			case 1:
				UIaddFeature();
				break;
			case 2:
				UIaddFeatureToPackage();
				break;
			case 3:
				UIlistFeatures();
				break;
			case 4:
				UIbrowseStatistic();
				break;
			case 5:
				UIgradeFromTest();
				break;
			case 100: break;
			
			default:
				printf("Wrong chose\n");
				break;
		}
	}while(mode!=100);

}

/* module entry point */
void grade_ui(struct module_context *ctx)
{
	grade((char*)ctx->root);
}
